using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Instance.Models;

public record Place(string Title,
                    DegreesMinutesSeconds Latitude,
                    DegreesMinutesSeconds Longitude)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, PlaceSourceGenerationContext.Default.Place);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Place))]
internal partial class PlaceSourceGenerationContext : JsonSerializerContext
{
}