using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Mirror.Length.Models;

public class Configuration
{

    protected Property.Models.Configuration _PropertyConfiguration;
    public string[] IgnoreExtensions { init; get; }
    public string PersonBirthdayFormat { init; get; }

    public Property.Models.Configuration PropertyConfiguration => _PropertyConfiguration;

    [JsonConstructor]
    public Configuration(Property.Models.Configuration propertyConfiguration,
                         string[] ignoreExtensions,
                         string personBirthdayFormat)
    {
        IgnoreExtensions = ignoreExtensions;
        PersonBirthdayFormat = personBirthdayFormat;
        _PropertyConfiguration = propertyConfiguration;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}