using System.Collections.ObjectModel;
using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record FilePair(FilePath FilePath,
                       bool IsUnique,
                       bool? IsNotUniqueAndNeedsReview,
                       ReadOnlyCollection<FilePath> Collection,
                       FilePath? Match)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, FilePairSourceGenerationContext.Default.FilePair);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(FilePair))]
public partial class FilePairSourceGenerationContext : JsonSerializerContext
{
}