using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public sealed record Identifier(string[] DirectoryNames,
                                string Extension,
                                bool? HasDateTimeOriginal,
                                int Id,
                                long Length,
                                string PaddedId,
                                long Ticks)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, IdentifierSourceGenerationContext.Default.Identifier);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Identifier))]
public partial class IdentifierSourceGenerationContext : JsonSerializerContext
{
}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Identifier[]))]
public partial class IdentifierCollectionSourceGenerationContext : JsonSerializerContext
{
}