using System.Collections.ObjectModel;

namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IDate
{

    public static DateTime GetMinimum(ExifDirectory exifDirectory) =>
        XDate.GetMinimum(exifDirectory);

    public static (int Season, string seasonName) GetSeason(int dayOfYear) =>
        XDate.GetSeason(dayOfYear);

    public static DateTime? GetDateTimeOriginal(ExifDirectory exifDirectory) =>
        XDate.GetDateTimeOriginal(exifDirectory);

    public static ReadOnlyCollection<DateTime> GetDateTimes(ExifDirectory exifDirectory) =>
        XDate.GetDateTimes(exifDirectory);

    public static (bool?, string[]) IsWrongYear(DirectoryInfo directoryInfo, FilePath filePath, ExifDirectory exifDirectory) =>
        XDate.IsWrongYear(directoryInfo, filePath, exifDirectory);

    internal DateTime TestStatic_GetMinimum(ExifDirectory exifDirectory) =>
        GetMinimum(exifDirectory);

    internal (int Season, string seasonName) TestStatic_GetSeason(int dayOfYear) =>
        GetSeason(dayOfYear);

    internal DateTime? TestStatic_GetDateTimeOriginal(ExifDirectory exifDirectory) =>
        GetDateTimeOriginal(exifDirectory);

    internal ReadOnlyCollection<DateTime> TestStatic_GetDateTimes(ExifDirectory exifDirectory) =>
        XDate.GetDateTimes(exifDirectory);

    internal (bool?, string[]) TestStatic_IsWrongYear(DirectoryInfo directoryInfo, FilePath filePath, ExifDirectory exifDirectory) =>
        IsWrongYear(directoryInfo, filePath, exifDirectory);

}