using System.Collections.ObjectModel;

namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IMetaBase
{

    public static string DateTimeFormat() =>
         "yyyy:MM:dd HH:mm:ss";

    public static string? GetMaker(ExifDirectory? exifDirectory) =>
        MetaBase.GetMaker(exifDirectory?.ExifBaseDirectories);

    public static string? GetModel(ExifDirectory? exifDirectory) =>
        MetaBase.GetModel(exifDirectory?.ExifBaseDirectories);

    public static int? GetOrientation(ExifDirectory? exifDirectory) =>
        MetaBase.GetOrientation(exifDirectory?.ExifBaseDirectories);

    public static int? GetWidth(ExifDirectoryBase[]? exifBaseDirectories) =>
        MetaBase.GetWidth(exifBaseDirectories);

    public static int? GetHeight(ExifDirectoryBase[]? exifBaseDirectories) =>
        MetaBase.GetHeight(exifBaseDirectories);

    public static string? GetMaker(ExifDirectoryBase[]? exifBaseDirectories) =>
        MetaBase.GetMaker(exifBaseDirectories);

    public static string? GetModel(ExifDirectoryBase[]? exifBaseDirectories) =>
        MetaBase.GetModel(exifBaseDirectories);

    public static DateTime? GetDateTime(string dateTimeFormat, string? value) =>
        MetaBase.GetDateTime(dateTimeFormat, value);

    public static int? GetOrientation(ExifDirectoryBase[]? exifBaseDirectories) =>
        MetaBase.GetOrientation(exifBaseDirectories);

    public static ReadOnlyCollection<string> GetKeywords(ExifDirectory? exifDirectory) =>
        MetaBase.GetKeywords(exifDirectory?.ExifBaseDirectories);

    public static ReadOnlyCollection<string> GetKeywords(ExifDirectoryBase[]? exifBaseDirectories) =>
        MetaBase.GetKeywords(exifBaseDirectories);

    internal string TestStatic_DateTimeFormat() =>
        DateTimeFormat();

    internal string? TestStatic_GetMaker(ExifDirectory? exifDirectory) =>
         GetMaker(exifDirectory);

    internal string? TestStatic_GetModel(ExifDirectory? exifDirectory) =>
         GetModel(exifDirectory);

    internal static int? TestStatic_GetWidth(ExifDirectoryBase[]? exifBaseDirectories) =>
        GetWidth(exifBaseDirectories);

    internal static int? TestStatic_GetHeight(ExifDirectoryBase[]? exifBaseDirectories) =>
        GetHeight(exifBaseDirectories);

    internal static string? TestStatic_GetMaker(ExifDirectoryBase[]? exifBaseDirectories) =>
        GetMaker(exifBaseDirectories);

    internal static string? TestStatic_GetModel(ExifDirectoryBase[]? exifBaseDirectories) =>
        GetModel(exifBaseDirectories);

    internal static DateTime? TestStatic_GetDateTime(string dateTimeFormat, string? value) =>
        GetDateTime(dateTimeFormat, value);

    internal static int? TestStatic_GetOrientation(ExifDirectoryBase[]? exifBaseDirectories) =>
        GetOrientation(exifBaseDirectories);

    internal static ReadOnlyCollection<string> TestStatic_GetKeywords(ExifDirectoryBase[]? exifBaseDirectories) =>
        GetKeywords(exifBaseDirectories);

}