namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IProperty
{ // ...

    DateTime TestStatic_GetDateTime(Models.Property? property) =>
        GetDateTime(property);
    static DateTime GetDateTime(Models.Property? property) =>
        Property.GetDateTime(property);

    DateTime TestStatic_GetMinimumDateTime(Models.Property? property) =>
        GetMinimumDateTime(property);
    static DateTime GetMinimumDateTime(Models.Property? property) =>
        Property.GetMinimumDateTime(property);

    (int Season, string seasonName) TestStatic_GetSeason(int dayOfYear) =>
        GetSeason(dayOfYear);
    static (int Season, string seasonName) GetSeason(int dayOfYear) =>
        Property.GetSeason(dayOfYear);

    string TestStatic_GetDiffRootDirectory(string diffPropertyDirectory) =>
        GetDiffRootDirectory(diffPropertyDirectory);
    static string GetDiffRootDirectory(string diffPropertyDirectory) =>
        Property.GetDiffRootDirectory(diffPropertyDirectory);

    (bool?, string[]) TestStatic_IsWrongYear(string[] segments, string year) =>
        IsWrongYear(segments, year);
    static (bool?, string[]) IsWrongYear(string[] segments, string year) =>
        Property.IsWrongYear(segments, year);

    (bool?, string[]) TestStatic_IsWrongYear(FilePath filePath, DateTime? dateTimeOriginal, List<DateTime> dateTimes) =>
        IsWrongYear(filePath, dateTimeOriginal, dateTimes);
    static (bool?, string[]) IsWrongYear(FilePath filePath, DateTime? dateTimeOriginal, List<DateTime> dateTimes) =>
        Property.IsWrongYear(filePath, dateTimeOriginal, dateTimes);

    List<DateTime> TestStatic_GetDateTimes(Models.Property property) =>
        GetDateTimes(property);
    static List<DateTime> GetDateTimes(Models.Property property) =>
        Property.GetDateTimes(property.CreationTime, property.LastWriteTime, property.DateTime, property.DateTimeDigitized, property.DateTimeFromName, property.DateTimeOriginal, property.GPSDateStamp);

    List<DateTime> TestStatic_GetDateTimes(DateTime creationTime, DateTime lastWriteTime, DateTime? dateTime, DateTime? dateTimeDigitized, DateTime? dateTimeFromName, DateTime? dateTimeOriginal, DateTime? gpsDateStamp) =>
        GetDateTimes(creationTime, lastWriteTime, dateTime, dateTimeDigitized, dateTimeFromName, dateTimeOriginal, gpsDateStamp);
    static List<DateTime> GetDateTimes(DateTime creationTime, DateTime lastWriteTime, DateTime? dateTime, DateTime? dateTimeDigitized, DateTime? dateTimeFromName, DateTime? dateTimeOriginal, DateTime? gpsDateStamp) =>
        Property.GetDateTimes(creationTime, lastWriteTime, dateTime, dateTimeDigitized, dateTimeFromName, dateTimeOriginal, gpsDateStamp);

}